import networkx as nx
import pdb
import random
import visualization as visual
import pickle


# computes community give a signed network

def change(pa,pb,na,nb):
    return pa-na+nb-pb
def seperate(x,com1,com2):
    if x in com1:
        return com1,com2
    else:
        return com2,com1

def four_categories(gr,x,com1,com2):
    same,diff  = seperate(x,com1,com2)
    nbrs = gr.neighbors(x)
    A = filter(lambda y:y in same,nbrs)
    B = filter(lambda y:y in diff,nbrs)
    PA = filter(lambda y:gr[x][y]['sign'] > 0,A)
    NA = list(set(A).difference(PA))
    PB = filter(lambda y:gr[x][y]['sign'] > 0,B)
    NB = list(set(B).difference(PB))
    #print change(len(PA),len(PB),len(NA),len(NB))
    return change(len(PA),len(PB),len(NA),len(NB))

def compute_objective(gr,com1,com2):
    # compute the value of the obejctive with this splitting
    frustation = 0
    for i in gr.edges(data=True):
        # check if the nodes
        x = 1  if i[0] in com1 else -1
        y = 1  if i[1] in com1 else -1
        if x*y>0 and i[2]['sign']==-1:
            frustation +=1
        if x*y<0 and i[2]['sign']==1:
            frustation +=1
    return frustation


def saveresults(frustu):
    print frustu
    visual.plotpoints( frustu.keys(),frustu.values())
    visual.saveplot('communities.png',"Change in the frustation value","Iteration #","Frustation value")
    visual.saveplot('communities.eps',"Change in the frustation value","Iteration #","Frustation value")
def greedy(gr):
    # a greedy approach to divide the nodes in to two communities such that sum of -ves within and positives between is least
    # divide the nodes into two groups randomly
    # iterate over the nodes in the graph and check if switching a node reduces the objective
    x = random.sample(gr.nodes(),len(gr.nodes())/2)
    com1 = dict(zip(x,[1]*len(x)))
    y = list(set(gr.nodes()).difference(x))
    com2 = dict(zip(y,[1]*len(y)))
    #return compute_objective(gr,com1,com2)
    # now brows through the nodes in both the groups
    visited = {}
    iterations = 0
    frustations = {}
    swappings = 0 
    prev = compute_objective(gr,com1,com2)
    while True:
        iterations = iterations +1
        print "iterations ",iterations
        for i in gr.nodes():
            change = four_categories(gr,i,com1,com2)
            if change < 0:
                if i in com1:
                    com1.pop(i)
                    com2[i] = 1
                else:
                    com2.pop(i)
                    com1[i] = 1
                swappings +=1
                f = compute_objective(gr,com1,com2)
                frustations[swappings] = f
                if f > prev:
                    pdb.set_trace()
                    print "error---------------------"
                prev = f
        else:
            break
    pickle.dump(frustations,open('frustation.obj','w'))
    saveresults(frustations)


if __name__=='__main__':
    g = nx.Graph()
    g.add_edge(1,3,sign=1)
    g.add_edge(3,4,sign=1)
    g.add_edge(1,2,sign=-1)
    g.add_edge(2,3,sign=-1)
    g.add_edge(2,4,sign=-1)
    com1 = {1:1,2:2}
    com2 = {3:1,4:2}
    four_categories(g,2,com1,com2)
