# studies the degree distribution of the nodes in the graph

import networkx as nx
import pdb
import sys
from collections import Counter
import matplotlib.pyplot as plt
import math

def getdegrees(gr):
    # expects a directed graph
    v = gr.in_degree().values()
    counts = Counter(v)
    return counts

def getfraction(s):
    # get the values in terms of the fractions
    ysum = sum(s.values())
    yval = [float(x)/ysum for x in s.values()]
    return dict(zip(s.keys(),yval))

def getparams(s):
    # get the parameters for the power law
    # get the values for k = 2 and k= 4
    # divide the corresponding values of the f(k) also
    r = float(s[2])/float(s[4])
    # get log(r) base 2
    alpha = math.log(r,2)
    c = float(s[2]) * math.pow(2,alpha)
    return alpha,c
def drawhist(s,f,title,alpha=-1,c=-1):
    if alpha > 0 and c > 0:
        # draw the computed power law also
        estimated = map(lambda x:float(c)/math.pow(x,alpha),s.keys()[1:200])
    print estimated
    #pdb.set_trace()
    #plt.hist(s,facecolor='green',alpha=0.75,bins=100)
    plt.plot(s.keys()[:200],s.values()[:200],'bs',label="Observed distribution")
    plt.plot(s.keys()[1:200],estimated,'r*',label="Power law distribution")
    plt.title(title)
    plt.annotate('alpha = '+str(alpha), xy=(10, s.values()[10]), xytext=(15, 0.2),arrowprops=dict(facecolor='black', shrink=0.05),)
    plt.ylabel("Fraction of nodes")
    plt.xlabel("Degree")
    plt.legend()
    plt.savefig(f)
    plt.close()
    plt.title("Log log plot of degree distribution")
    plt.ylabel("Fraction of nodes")
    plt.xlabel("Degree")
    plt.loglog(s.keys()[1:1000],s.values()[1:1000],color='k')
    plt.savefig('loglog.eps')
    pdb.set_trace()
