import networkx as nx
import sys
import pdb
from pylab import *

def common_neighbors(gr,n1,n2):
    # compute the number of common neighbors b/w n1 and n2
   nbr1 = set(gr.neighbors(n1)) 
   nbr2 = set(gr.neighbors(n2)) 
   return len(nbr1.intersection(nbr2))


def plot_embed(nbrs,fil="out.png",xlab="",ylab="",tit="",maxnbr=-1,col='b*',lab=""):
    x,y = get_points(nbrs,maxnbr)
    plot(x,y,col,label=lab)
    #xlabel(xlab)
    #ylabel(ylab)
    #savefig(fil)
    #close()

def get_points(nbrs,maxnbr):
    # get the points that have to be plotted
    k = filter(lambda x:x<maxnbr,nbrs.keys())
    v = map(lambda x:float(nbrs[x][0])/(nbrs[x][0]+nbrs[x][1]),k)
    return k,v
def compute_embeddedness(gr,pos,lab="sign"):
    # compute the embeddedness of the graph 
    # pos is the probability of an edge having positive sign
    nbrs = {} # key is the number of neighbors and the value is a tuple (positive,negative) counts
    for i in gr.edges(data=True):
        # compute the number of common neighbors
        cmn = common_neighbors(gr,i[0],i[1])
        if i[2][lab] == 1:
            index=0
        else:
            index=1
        if cmn in nbrs:
            nbrs[cmn][index] +=1
        else:
            l = [0,0]
            l[index] = 1
            nbrs[cmn] = l
    return nbrs
