import sys
import networkx as nx
import pdb

class Tree:

    def __init__(self,val):
        self.val = val # number of negative edges within itself
        self.left = None
        self.right = None
        self.mark = False
        self.pval = 0 # number of positive edges between its left and right children

    def print_tree(self):
        # print the level order of the tree
        queue = [self,"\n"]
        while len(queue) > 1:
            c = queue.pop(0)
            if type(c) == type('\n'):
                ## append a newline
                print "\n"
                queue.append(c)
            else:
                # print this node and also the children
                print "Nval = ",c.val,"  Pval = ",c.pval,"----------",
                if c.left:
                    queue.append(c.left)
                if c.right:
                    queue.append(c.right)
    def set_pval(self,pv):
        self.pval = pv # number of positive edges between the children

    def add_left_val(self,n):
        # create a node for the left
        node = Tree(n)
        self.left = node
        return node
    def add_right_val(self,n):
        # create a node for the left
        node = Tree(n)
        self.right = node
        return node

    def add_children(self,l,r):
        ln = self.add_left_val(l)
        rn = self.add_right_val(r)
        return ln,rn
    def is_leaf(self):
        return not self.left and not self.right
    def set_mark(self):
        self.mark = True
    def min_cut(self):
        # find the set of nodes such that the total value is minimum
        if self.is_leaf():
            self.set_mark()
            return self.val
        else: # find the sum of its children and see if it is greater than the val
            chsum = self.left.min_cut() + self.right.min_cut() + self.pval
            if chsum < self.val:
                return chsum
            else:
                self.set_mark()
                return self.val

    def marked_nodes(self):
        # find the nodes that are marked
        # post order traversal of the tree to find the nodes that are marked
        if self.mark:
            yield self.val
        else:
            if not self.is_leaf():
                self.left.marked_nodes()
                self.right.marked_nodes()

    def optimum_frustration(self):
        return sum([i for i in self.marked_nodes()])
