import networkx as nx
import pdb
import random
import communities as community
import pickle
import readdb as db
import sys
from collections import defaultdict

def positive(gr):
    # return a a graph with only positive edges
    ebunch = filter(lambda x:x[2]['sign'] < 0,gr.edges(data=True))
    gr.remove_edges_from(ebunch)
def compute_scores(gr,clus):
    # compute the dot product of each cluster with itself
    r1 = [dict(zip(v,[k]*len(v))).items() for k,v in clus.items()]
    revmapping = dict(reduce(lambda x,y:x+y,r1,[]))
    scores = {}
    for i in gr.edges(data=True):
        c1 = revmapping[i[0]]
        c2 = revmapping[i[1]]
        #print c1,c2
        if c1==c2 and i[2]['sign']==1: # consider only the positive edges
            try:
                scores[c1] +=1
            except KeyError:
                scores[c1] = 1
    return {k:v/float(len(clus[k])**2) for k,v in  scores.items()}

def delta(x,y):
    if x==y:
        return 1
    return 0

def convergence(prev,curr):
    for key in prev.keys():
        if len(prev[key].symmetric_difference(curr[key]))==0:
            continue
        else:
            return False
    return True
def frustration(clus,gr):
    r1 = [dict(zip(v,[k]*len(v))).items() for k,v in clus.items()]
    revmapping = dict(reduce(lambda x,y:x+y,r1,[]))
    fval = 0
    ksize = len(clus.keys())
    for i in gr.edges(data=True):
        try:
            c1 = revmapping[i[0]]
        except KeyError:
            c1 = random.randint(1,k)
            revmapping[i[0]] = c1
        try:
            c2 = revmapping[i[1]]
        except KeyError:
            c2 = random.randint(1,k)
            revmapping[i[1]] = c2
        if i[2]['sign'] == 1:
            fval += 1-delta(c1,c2)
        else:
            fval += delta(c1,c2)
    return fval

def kmeans(gr,k=2):
    ## cluster the graph nodes using kernel k means..minimizing ratio association as mentioned in inderjit dhillons paper
    clusters = defaultdict(set)
    backup = gr.copy()
    positive(gr)
    print type(gr)
    for i in gr.nodes():
        r = random.randint(1,k)
        clusters[r].add(i)
    ## now for each point find the new clustering
    iterations = 0
    while True:
        ## compute the scores for each of the clusters
        scores = compute_scores(gr,clusters)
        newClusters = defaultdict(set)
        for i in gr.nodes():
            minScore = ()
            newClus = -1
            # get the neighbors for this point
            nbrs = set(gr.neighbors(i))
            for clus,verts in clusters.items():
                # compute the distance to this cluster center
                t1 = (-2 * len( nbrs.intersection(verts)))/ float( len(verts)) 
                try:
                    t2 =  scores[clus]
                except KeyError:
                    # if the numerator of the second term is zero
                    t2 = 0
                if t1  + t2 <= minScore:
                    minScore = t1+t2
                    newClus = clus
            newClusters[newClus].add(i)
        #print newClusters
        if convergence(clusters,newClusters) or iterations > 100:
            return frustration(clusters,backup),clusters
        clusters = newClusters
        iterations = iterations + 1
        #if iterations > 100:
        #    return clusters
