import modularity as md
import networkx as nx
import pdb
from numpy import *


def compute_mod(punit,nunit,cluster,svector):
    #pdb.set_trace()
    actual = cluster.multiply_vector(svector)
    pfactor = punit*svector
    nfactor = nunit*svector
    return sum(svector*(actual-pfactor+nfactor))

def max_key(a):
    ## find the key for which the value is the maximum
    b = dict(map(lambda item: (item[1],item[0]),a.items()))
    return b[max(b.keys())]

def compute_svec(pi,ni):
    svec = array([0]*(len(pi)+len(ni)))
    for i in pi:
        svec[i] +=1
    for i in ni:
        svec[i] -=1
    return svec
def get_degree_map(indices,deg_vec):
    return dict(zip(indices,deg_vec))

def get_best(svector,imp,indices):
    ## check if there is any sequence that leads to a positive improvement
    if len(imp) < 1:
        print "return without change"
        return svector

    m = max(imp)
    if m <= 0:
        print "return without change"
        return svector
    ## else get the first index at which this occurs
    index = imp.index(m)
    ## change the assignments upto index
    new_svector = svector.copy()
    for iter in range(index+1):
        new_svector[indices[iter]] = -1*svector[indices[iter]]
    return new_svector

def improve(cluster,pi,ni,zi,pv,nv):
    ### before performing the next iteration try to improve
    #print "before moving ",pi,ni
    #print "before improve"
    #pdb.set_trace()
    svector = compute_svec(pi,ni)
    svec_bkp = svector.copy()
    #unmoved = set(range(len(cluster.vertices)))
    unmoved = set(zi) ## zi are indices of the vertices for which improve has to be performed
    punit = cluster.pos_diag()
    nunit = cluster.neg_diag()
    improve = []
    indices = []
    pmap = get_degree_map(pi,cluster.pd)
    nmap = get_degree_map(ni,cluster.nd)
    #for i in range(len(cluster.vertices)):
    for i in range(len(unmoved)):
        ## compute the current modularity
        #initial = compute_mod(punit,nunit,cluster,svector)
        score ={}
        ### compute the dot product of a row degree matrix and the cluster column#
        psum = cluster.compute_psum(svector)
        nsum = cluster.compute_nsum(svector)
        for index,un in enumerate(unmoved):
            ## move un and compute the value again
            ## compute the change in the score by moving un
            ### get the row corresponding to the un index
            moving_row = cluster.adj.getrow(un)
            ## multiply with the svector
            asum = (moving_row*svector)[0]
            un_sign = svector[un]
            total_change = -2*un_sign * (asum - cluster.pd[un]*psum + cluster.nd[un]*nsum)
            score[un] = total_change
            #print index
            #pdb.set_trace()
            #svector[un] = -1*svector[un]
            #newmod = compute_mod(punit,nunit,cluster,svector)
            #svector[un] = -1*svector[un]
            if index > 200:
                break
        maxindex = max_key(score)
        svector[maxindex] = -1*svector[maxindex]
        indices.append(maxindex)
        #print "max change",score[maxindex]
        try:
            improve.append(improve[-1]+score[maxindex])
        except IndexError:
            improve.append(score[maxindex])
        ### update the svector
        unmoved.difference_update([maxindex])
        if i>200:
            break
    #print svector
    #pdb.set_trace()
    m = 1 if len(improve)==0 else max(improve)
    if m <= 0:
        return pi,pv,ni,nv
    else:
        # find the max decrease
        lastindex = (len(improve) - 1) - improve[::-1].index(m)
        for chng in indices[:lastindex+1]:
            svec_bkp[chng] *=-1
        #pdb.set_trace()
        ## find the new clusters..first compute the new assignment vector
        #return c.split_cluster([cmap_bkp[x] for x in c.vertices])
        #new_svector = get_best(svec_bkp,improve,indices)
        new_pi,new_pv = cluster.get_vertices(svec_bkp,1)
        new_ni,new_nv = cluster.get_vertices(svec_bkp,-1)
        #print "after moving ",pi,ni
        #print "after improve"
        return new_pi,new_pv,new_ni,new_nv
