import networkx as nx
import pdb
import sys

import readdb as db
import stats as stat
import embeddedness as embed
import permute_signs as permute
import visualization as visual
import triangles as tri
import degree as deg
import graphfit as fit
import communities as community
import modularity as mdl
import sample_graph as samp
import pickle
import kkmeans as kk
import specfrus as spfrus # spectral algorithm to minimize frustration

if __name__=='__main__':
    if len(sys.argv) < 1:
        print "Usage : python script input "
    else:
        #### A sample graph network
        #gr = samp.sample_clique(3,3,2)
        #visual.plot_graph(gr,'nw.eps',3,4)
        gr = db.read_epinion(sys.argv[1])
        #################un comment the next line to work on the undirected part
        gr = db.undirected_graph(gr)

        ####Algorithm 1 ---- embeddedness in the graph###########
        #pos = stat.positive_abundance(gr)
        #rangraph = permute.random_graph(gr,pos)
        #nbrs = embed.compute_embeddedness(gr,pos)
        #nbrs2 = embed.compute_embeddedness(rangraph,pos)
        #print nbrs
        #embed.plot_embed(nbrs,'real.png','Common Neighbors','Fraction of postive edges',"Testing embeddness",50,'b*',"Epinions")
        #embed.plot_embed(nbrs2,'artificial.png','Common Neighbors','Fraction of postive edges',"Testing embeddness",50,'r+',"Random")
        #visual.saveplot('comparison.png','Common Neighbors','Fraction of postive edges','Embeddedness of edges')
        #tri.triads(gr,0,'epinions_traids.obj')
        
        ###### Algorithm 2 -- undirected traids in the graph ########
        #pos = stat.positive_abundance(gr)
        #rangraph = permute.random_graph(gr,pos)
        #tri.triads(gr,0,'epinions_traids_undirected.obj')
        #pdb.set_trace()
        #tri.triads(rangraph,0,'epinions_random_traids.obj')

        ###########Algorithm 3 -- degree distribution in the directed graph
        #degrees = deg.getdegrees(gr)
        #fraction = deg.getfraction(degrees)
        #alpha,c = deg.getparams(fraction)
        #print alpha,c
        #deg.drawhist( fraction,'degreedistri_epinion.eps','Degree distribution in epinions',alpha,c)
        #print deg.getparams(deg.getdegrees(gr))

        #### Fit the data
        #fit.fitgaussian(gr,"gfit.png")

        ################ Comunities in signed network
        #community.greedy(gr)
        #pdb.set_trace()

        ################ Compute the modularity of the network
        #f,v,top = mdl.runner(gr,30)
        #pdb.set_trace()


        ################## divide the network into multiple clusters maximizing the modularity
        clus,tmapping,mincut,marked,root = mdl.multiple_clusters(gr,30)
        fval = mdl.frustation_val(clus,gr)
        pickle.dump([clus,tmapping,mincut,marked,root],open(sys.argv[2],'w'))
        #pdb.set_trace()

        ##################### Kernel kmeans on the network ##################################
        #k = range(70,100,5)
        #sols = []
        #for kval in k:
        #    fval,clus = kk.kmeans(gr,kval)
        #    sols.append((fval,[len(v) for k,v in clus.items()],kval))
        #pickle.dump(sols,open('kernelkmeans3.obj','w'))
        #pdb.set_trace()

        ###################### Spectral algorithm for minimizing frustration value
        #clus,fval = spfrus.optimal_frustration(gr)
        #clus,fval= pickle.load(open('spectral_frustration.obj'))
        #x = pickle.load(open('epinions_improve_run2.obj'))
        #x = pickle.load(open('epinions_Noimprove_run2.obj'))
        #clus = x[0]
        #fval = x[2]
        #pdb.set_trace()
        #Q = spfrus.compute_modularity(clus,gr)
        #pickle.dump([clus,fval,Q],open(sys.argv[2],'w'))
        #pickle.dump([clus,fval],open(sys.argv[2],'w'))
        #pdb.set_trace()
