# analyze the degree distribution of the negative edges
# X axis is the fraction of negative edges on a node
# Y axis is the number of fraction of nodes in the database

import readdb as db
import pdb
import sys
from collections import defaultdict
import matplotlib.pyplot as plt
import numpy as np


def plotvals(vals,xlab,ylab,title,file):
    plt.close()
    plt.hist(vals,50)
    plt.xlabel(xlab)
    plt.ylabel(ylab)
    plt.title(title)
    plt.savefig(file)
def ntop_ratio(ratio,gr,threshold):
    # historgram of ratios > 1 
    hvals = dict([(k,v) for k,v in ratio.items() if v>threshold])
    return hvals

def analyze(r1,g1,r2,g2):
    vals = []
    d1 = float(len(g1))
    d2 = float(len(g2))
    v1 = [] # vzalues for epinions
    v2 = [] # vzalues for epinions
    for i in range(1,15,1):
        h1 = ntop_ratio(r1,g1,i)
        h2 = ntop_ratio(r2,g2,i)
        #vals.append((len(h1)/d1,len(h2)/d2))
        v1.append((i,len(h1)/d1))
        v2.append((i,len(h2)/d2))
    pdb.set_trace()
    x1 = [i[0] for i in v1]
    y1 = [i[1] for i in v1]
    x2 = [i[0] for i in v2]
    y2 = [i[1] for i in v2]
    plt.plot(x1,y1,'k--',label='Epinions')
    plt.plot(x2,y2,'k:',label='Slashdot')
    plt.legend(shadow=True,fancybox=True)
    plt.xlabel('Negative to Positive Edge Ratio (nir) ')
    plt.ylabel('Fraction of Nodes')
    plt.savefig('neg_compare.eps',dpi=2000)
    #h1 = ntop_ratio(r1,g1)
    #h2 = ntop_ratio(r2,g2)
    #print "got ratios"
    #plotvals(h1.values(),"X","Y","title",'epinions_neg.eps')
    #plotvals(h2.values(),"X","Y","title",'slashdot_neg.eps')

def get_ratio(gr,N,P):
    ratios = {} # 
    for i in gr.nodes():
        if P[i] > 0:
            ratios[i] = N[i]/(1.0*P[i])
    return ratios
def get_deg(gr):
    ndegs = defaultdict(int)
    pdegs = defaultdict(int)
    for u,v,attrs in gr.edges(data=True):
        if attrs['sign']==-1:
            ndegs[u] +=1
            ndegs[v] +=1
        else:
            pdegs[u] +=1
            pdegs[v] +=1

    return ndegs,pdegs
if __name__=='__main__':
    if len(sys.argv) < 2:
        print "Usage : python script input "
    else:
        #### A sample graph network
        gr = db.read_epinion(sys.argv[1])
        gr2 = db.read_epinion(sys.argv[2])
        N,V = get_deg(gr)
        N2,V2 = get_deg(gr2)
        ratio = get_ratio(gr,N,V)
        ratio2 = get_ratio(gr2,N2,V2)
        print "read vals"
        analyze(ratio,gr,ratio2,gr2)
        #pdb.set_trace()
