#module to read the graph database 
import sys
import pdb
import networkx as nx

def read_epinion(inp,delim='\t',num=0):
    # num is the number of lines to ignore from the input file
    # if not mentioned remove all the lines that start with a #
    # return a directed graph where the each edge has a sign +/- 1
    # each line in the input has a start id end id and the sign for the edge
    gr = nx.DiGraph()
    f = open(inp)
    while True:
        li = f.readline()
        li = li.strip()
        if len(li) < 2:
            break
        if li.startswith("#"):
            continue
        sp = li.split(delim)
        gr.add_edge(int(sp[0]),int(sp[1]),sign=int(sp[2]))
        #gr.add_edge(int(sp[0]),int(sp[1]),weight=int(sp[2]))
    return gr

def undirected_graph(gr):
    # return an undirected version of the input graph
    return nx.Graph(gr)

if __name__ == '__main__':
    if len(sys.argv) < 2:
        print "Usage : python script input"
    else:
        gr = read_epinion(sys.argv[1])
