import networkx as nx
import pdb
import random

def sample():
    gr = nx.Graph()
    gr.add_edge(0,1,sign=-1)
    gr.add_edge(1,2,sign=-1)
    gr.add_edge(0,2,sign=-1)
    return gr

def add_edges(gr,start,end):
    ## add edges between all nodes [start,end]
    for i in range(start,end):
        for j in range(i+1,end):
            gr.add_edge(i,j,sign=1)
            #gr.add_edge(i,j,weight=1)

def add_neg_edges(c1,c2,size,num,gr):
    ## size is the size of each cluster and num is the number of neg edges to be added
    ## generate all pairs with nodes from c1 and c2
    pairs = []
    for i in range(c1*size,(c1+1)*size):
        for j in range(c2*size,(c2+1)*size):
            pairs.append((i,j))
    ## randomly sample  num pairs from all the pairs
    eds = random.sample(pairs,num)
    map(lambda x:gr.add_edge(x[0],x[1],sign=-1),eds)
    #map(lambda x:gr.add_edge(x[0],x[1],weight=-1),eds)


def sample_clique(size=4,num=4,neg=2):
    ## generate a graph with num cliques each of size "size" and number of -ve edges between every pair 2 randomly
    gr = nx.Graph()
    num_vertices = size*num
    map(lambda x:add_edges(gr,size*x,size*(x+1)),range(num))
    ## add random edges between pair of clusters
    for i in range(num):
        for j in range(i+1,num):
            ## add neg number of random edges between these two clusters
            add_neg_edges(i,j,size,neg,gr)
    ## 
    print gr.nodes()
    print gr.edges(data=True)
    #print filter(lambda x:x[2]['sign'] < 0,gr.edges(data=True))
    return gr

if __name__=='__main__':
    sample_clique(3,3,1)
