from scipy import *
from numpy import *
from scipy.sparse import *
import pdb


def pull(matr,rows,cols):
    ### takes as input a csr matrix and extracts a submatrix in csr format
    if type(matr) != coo_matrix:
        matr = matr.tocoo()
    gr = -1 * ones(matr.shape[0])
    gc = -1 * ones(matr.shape[1])
    lr = len(rows)
    lc = len(cols)
    ar = arange(0, lr)
    ac = arange(0, lc)
    gr[rows[ar]] = ar
    gc[cols[ac]] = ac
    mrow = matr.row
    mcol = matr.col
    newelem = (gr[mrow] > -1) & (gc[mcol] > -1)
    newrows = mrow[newelem]
    newcols = mcol[newelem]
    return coo_matrix((matr.data[newelem], array([gr[newrows], gc[newcols]])),(lr, lc)).tocsr()

if __name__=='__main__':
    row  = array([0,3,1,0])
    col  = array([0,3,1,2])
    data = array([4,5,7,9])
    x = csr_matrix( (data,(row,col)),shape=(4,4))
    print x.todense()
    y = pull(x,array([0,1,2]),array([0,1,2]))
    print y.todense()
#x = S.sparse.coo_matrix( (data,(row,col)), shape=(4,4) ).todense()

