# computes undirected triangles in a graph
import networkx as nx
import pdb
import sys
import pickle

def typeOfTriad(x,y,z,gr):
    # attribute is weight
    r1 = gr.edge[x][y]['sign']
    r2 = gr.edge[y][z]['sign']
    r3 = gr.edge[x][z]['sign']
    x = filter(lambda x:x>0,[r1,r2,r3])
    return len(x)



def get_triads(gr,triadType):
    ## get all the traids of the triadType
    nodes_nbrs = iter(gr.adj.items())
    counts = {}
    for v,v_nbrs in nodes_nbrs:
        #print v,v_nbrs
        vs = set(v_nbrs)
        if v in vs:
            vs.remove(v)
        for w in vs:
            ws  =set(gr[w])
            if w in ws:
                ws.remove(w)
            # compute the intersection vs and ws
            i = vs.intersection(ws)
            for close in i:
                #check which kind of triangle it is
                r = typeOfTriad(v,w,close,gr)
                if r == triadType:
                    yield (v,w,close)

def triads(gr,f=None,o="out.obj"):
    # compute all the triangles in the graph and apply function to each such traingle
    nodes_nbrs = iter(gr.adj.items())
    counts = {}
    for v,v_nbrs in nodes_nbrs:
        #print v,v_nbrs
        vs = set(v_nbrs)
        if v in vs:
            vs.remove(v)
        for w in vs:
            ws  =set(gr[w])
            if w in ws:
                ws.remove(w)
            # compute the intersection vs and ws
            i = vs.intersection(ws)
            for close in i:
                #check which kind of triangle it is
                r = typeOfTriad(v,w,close,gr)
                if r in counts:
                    counts[r] += 1
                else:
                    counts[r] = 1
    vals = [counts[x]/6 for x in counts.keys()]
    # save the dictionary to a file
    pickle.dump(dict(zip(counts.keys(),vals)),open(o,'w'))
    return dict(zip(counts.keys(),vals))
 
if __name__ == '__main__':
    gr = nx.Graph()
    gr.add_edge(1,2,sign=-1)
    gr.add_edge(1,3,sign=-1)
    gr.add_edge(3,2,sign=1)
    gr.add_edge(1,4,sign=1)
    gr.add_edge(1,5,sign=-1)
    gr.add_edge(4,5,sign=1)
    print triads(gr)
